const NOTIFY_STATE_DOCUMENT =
  Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT; 

var idhref, idmiz, index, url, currentURL, node;
var SpurlPref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('spurlbar.settings.');
// The Global Sidebar Object
var mysidebar;
function getSideBar() {
	if (!mysidebar) {
		mysidebar = top.document.getElementById('sidebar').contentWindow;
	}
	return mysidebar;
}


function LoadSpurl(currentLocation, currentTitle) {
	var SpurlSideUrl = 'http://www.spurl.net/spurlbar1.php';
	var browser=getSideBar().document.getElementById("spurlBrowser");
	browser.webNavigation.loadURI(SpurlSideUrl,0,null,null,null);
}

function clicked (event) {
	// quit if button is not 1 (middle click)
	if (event.button != 1 && !event.ctrlKey) return;
	if (event.button == 1) {
	if (event.target.tagName == "A") {
			if (event.target.href) {
				top.window.openNewTabWith(event.target.href,null,null,true);
				if (event.ctrlKey) SideBarClose ();
			}
		}
		return;
	}
	if (event.button == 0 && event.ctrlKey) {
		if (event.target.tagName == "A") {
			if (event.target.href) {
				top.window.loadURI(event.target.href,null,null,null);
			}
		}
		SideBarClose();
		return;
	} else {
		return;
	}
	

}

// This function is called right when the sidebar is opened
function onLoadSpurlPanel() {
	if (SpurlPref.prefHasUserValue ('spurl_static')) {
		if (SpurlPref.getBoolPref ('spurl_static')) {
			if (SpurlPref.prefHasUserValue ('spurl_width')) {
				var sidebar_width = SpurlPref.getCharPref('spurl_width');
				sidebar_width = sidebar_width.concat('px');
				top.document.getElementById('sidebar-box').width=sidebar_width;
			} else {
				top.document.getElementById('sidebar-box').width="213px";
			}
		}
	}
	LoadSpurl(window.top._content.location.href, window.top._content.document.title);
	if (document.getElementById("spurlContextMenu")){
        document.getElementById("spurlContextMenu").addEventListener("popupshowing",OnPopup,false);
   }
   document.getElementById("spurlBrowser").addProgressListener(nsBrowserStatusHandler,Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
   top.document.getElementById("sidebar-throbber").setAttribute("loading",true);
   }

/* Handler to track changes in sidebar, so that we can enable throbber */
var nsBrowserStatusHandler = {
	QueryInterface: function(aIID)
   {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsISupports))
      return this;
      throw Components.results.NS_NOINTERFACE;
   }, 
	onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus) {
		const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;    
		const nsIChannel = Components.interfaces.nsIChannel;
		const STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP; 
		const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START; 
		const STATE_IS_WINDOW = Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW; 
		const STATE_IS_REQUEST = Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST; 
		const STATE_IS_NETWORK = Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK;
        
		if (aStateFlags & STATE_IS_NETWORK && aStateFlags & STATE_START) {
			top.document.getElementById("sidebar-throbber").setAttribute("loading",true);
		}
		if (aStateFlags  == (STATE_IS_WINDOW|STATE_IS_NETWORK|STATE_STOP)) {
			top.document.getElementById("sidebar-throbber").removeAttribute("loading");
   		} 
		return 0;
	},
   onLocationChange: function(aProgress, aRequest, aURI)  { return 0; },
   onProgressChange: function() {return 0;},
   onStatusChange: function() {return 0;},
   onSecurityChange: function() {return 0;},
   onLinkIconAvailable: function() {return 0;} 
}
function openPart (part) { 
	if (part == "MySpurls") 
		top.window.loadURI("http://www.spurl.net/myspurls/",null,null,null);
	if (part == "Export") 
		top.window.loadURI("http://www.spurl.net/myspurls/export.php",null,null,null);
	if (part == "Streams")
		top.window.loadURI("http://stream.spurl.net",null,null,null);
	if (part == "Forum")
		top.window.loadURI("http://www.spurl.net/help/forum/",null,null,null);
		
}
function SideBarClose() {
	top.toggleSidebar();
	top.togglespurlbar-button(!spurlbar-button.checked);
}
function OnPopup () {
	var item=document.getElementById("hiddenstatus");
	var node = document.popupNode;
    var nodeLocalName = node.localName.toUpperCase();
    spurlaction.init ();
	if (nodeLocalName === "A" && idmiz != "") {
		item.hidden = false;
	} else {
		item.hidden = true;
	}
}
var spurlaction = {
	init: function () {
		node = document.popupNode;
		doc = document.getElementById("spurlBrowser").contentDocument;
		if (node.localName.toUpperCase() != "A") return;
		currentURL= document.getElementById("spurlBrowser").webNavigation.currentURI;
		if (doc.getElementById('tab_quick').getAttribute("class") == "active"
			|| doc.getElementById('tab_tags').getAttribute("class") == "active") {
			idhref=node.getAttribute("onMouseDown");
			index = idhref.indexOf('id=')+3;
			if (idhref.indexOf('id=') == -1) return; // do that to eliminate 'more...' seen as spurl
		} else if (doc.getElementById('tab_my').getAttribute("class") == "active") {
			idmiz="i"+node.id.substring(1);
			idhref=node.ownerDocument.getElementById(idmiz).parentNode.href;
			index = idhref.indexOf('id=')+3;
		} else {
			idmiz="";
			return;
		}
		idmiz = idhref.substring(index).replace ('\'','');
	},
	modify: function () { 
		url="http://www.spurl.net/myspurls/editspurl.php?id=";
		url = url.concat(idmiz);
		top.window._content.location.href = url;
	},
	copy: function () { 
		url="http://www.spurl.net/myspurls/managespurls.php?action=copy&spurlid=";
		url = url.concat(idmiz);
		top.window._content.location.href = url;
	},
	del: function () { 
		url="http://www.spurl.net/myspurls/managespurls.php?action=delete&spurlid=";
		url = url.concat(idmiz);
		top.window._content.location.href = url;
	}
}

function OpenCache() {
    var node = document.popupNode;
    var selection = "http://cache.spurl.net/?url=";
    var nodeLocalName = node.localName.toUpperCase();
    
	if (nodeLocalName == "A") {
    	selection = selection.concat(escape(node.href));
    } 
	top.window._content.location.href = selection;
}

function OpenInNewTab() {
    var node = document.popupNode;
    var selection = "";
    var nodeLocalName = node.localName.toUpperCase();
    if (nodeLocalName == "A") {
        selection = node.href;
    } 
	top.window.openNewTabWith(selection,null,null,true);
}

function copyLink () {
        var clipboard = Components.classes['@mozilla.org/widget/clipboardhelper;1'].getService(Components.interfaces.nsIClipboardHelper );
        clipboard.copyString(document.popupNode.href);
}
